# Import things

import os
import shutil



# Initialize variables

global_path = os.path.dirname(os.path.realpath(__file__))







# CLONE SETTINGS FUNCTIONS



# Delete other sections

target_path = os.path.join(global_path, "Data Pack", "data", "build", "functions", "player", "click", "settings")

if os.path.exists(os.path.join(target_path, "cave")):
    shutil.rmtree(os.path.join(target_path, "cave"))
if os.path.exists(os.path.join(target_path, "city")):
    shutil.rmtree(os.path.join(target_path, "city"))
if os.path.exists(os.path.join(target_path, "ice")):
    shutil.rmtree(os.path.join(target_path, "ice"))



# Run through files

for subdir, dirs, files in os.walk(os.path.join(target_path, "forest")):
    # Define local path
    local_path = subdir[len(os.path.join(target_path, "forest")) + 1:]

    # Iterate through files
    for file in files:
        # Get contents of file
        with open(os.path.join(subdir, file), "r", encoding="utf-8") as f:
            contents = f.read()

        # Iterate through arena types
        for arena in [("cave", "2"), ("city", "3"), ("ice", "4")]:
            # Modify arena names
            lines = contents.replace("forest", arena[0]).split("\n")

            # Iterate through lines to modify coordinates
            for index in range(len(lines)):
                line = lines[index]

                # Modify coordinates if they exist
                if "data modify block " in line:
                    coords = line[line.index("data modify block ") + 18:].split(" ")[:3]

                    # Convert based on arena type
                    if arena[0] == "cave":
                        coords = [str(- int(coords[0])), coords[1], str(- int(coords[2]))]
                    elif arena[0] == "city":
                        coords = [str(- int(coords[2])), coords[1], str(int(coords[0]))]
                    elif arena[0] == "ice":
                        coords = [str(int(coords[2])), coords[1], str(- int(coords[0]))]

                    # Write coordinates back into line
                    lines[index] = line[:line.index("data modify block ") + 18] + " ".join(coords) + " " + " ".join(line[line.index("data modify block") + 18:].split(" ")[3:])

            # Write contents to file
            if not os.path.exists(os.path.join(target_path, arena[0], local_path)):
                os.makedirs(os.path.join(target_path, arena[0], local_path))
            with open(os.path.join(target_path, arena[0], local_path, file), "w", encoding="utf-8") as f:
                f.write("\n".join(lines))







# CLONE PHASE FUNCTIONS



# Delete other sections

target_path = os.path.join(global_path, "Data Pack", "data", "build", "functions", "phase")

if os.path.exists(os.path.join(target_path, "cave")):
    shutil.rmtree(os.path.join(target_path, "cave"))
if os.path.exists(os.path.join(target_path, "city")):
    shutil.rmtree(os.path.join(target_path, "city"))
if os.path.exists(os.path.join(target_path, "ice")):
    shutil.rmtree(os.path.join(target_path, "ice"))



# Run through files

for subdir, dirs, files in os.walk(os.path.join(target_path, "forest")):
    # Define local path
    local_path = subdir[len(os.path.join(target_path, "forest")) + 1:]

    # Iterate through files
    for file in files:
        # Get contents of file
        with open(os.path.join(subdir, file), "r", encoding="utf-8") as f:
            contents = f.read()

        # Iterate through arena types
        for arena in [("cave", "2", "tuff", "576 0 0"), ("city", "3", "smooth_quartz", "0 0 -576"), ("ice", "4", "light_blue_terracotta", "0 0 576")]:
            # Modify arena names
            lines = contents.replace("forest", arena[0]).replace("arena=1", "arena=" + arena[1]).replace("arena 1", "arena " + arena[1]).replace("#plot_arena value 1", "#plot_arena value " + arena[1]).replace("brown_concrete", arena[2]).replace("-576 0 0", arena[3]).split("\n")

            # Iterate through lines to modify coordinates
            for index in range(len(lines)):
                line = lines[index]

                # Modify coordinates if they exist
                string = "data modify block "
                if string in line:
                    coords = line[line.index(string) + 18:].split(" ")[:3]

                    # Convert based on arena type
                    if arena[0] == "cave":
                        coords = [str(- int(coords[0])), coords[1], str(- int(coords[2]))]
                    elif arena[0] == "city":
                        coords = [str(- int(coords[2])), coords[1], str(int(coords[0]))]
                    elif arena[0] == "ice":
                        coords = [str(int(coords[2])), coords[1], str(- int(coords[0]))]

                    # Write coordinates back into line
                    lines[index] = line[:line.index(string) + 18] + " ".join(coords) + " " + " ".join(line[line.index(string) + 18:].split(" ")[3:])

                string = "data modify storage build:data action_queue append value "
                if string in line:
                    instruction = int(line[line.index(string) + 57:])
                    coords = [((instruction//1000)%1000 - 64)*16, (instruction%1000 - 64)*16]
                    axis = (instruction//1000000)%10

                    # Convert based on arena type
                    if arena[0] == "cave":
                        coords = [- coords[0], - coords[1]]
                    elif arena[0] == "city":
                        coords = [- coords[1], coords[0]]
                        axis = 0
                    elif arena[0] == "ice":
                        coords = [coords[1], - coords[0]]
                        axis = 0

                    # Write instruction back into line
                    instruction = (instruction//10000000)*10000000 + axis*1000000 + (coords[0]//16 + 64)*1000 + coords[1]//16 + 64
                    lines[index] = line[:line.index(string) + 57] + str(instruction)

                # Modify specific lines
                if arena[0] in ["city", "ice"]:
                    if line == "execute store result score #voting_side value run data get entity @s Pos[0]":
                        lines[index] = "execute store result score #voting_side value run data get entity @s Pos[2]"
                    elif line == "scoreboard players add #action value 101000000":
                        lines[index] = "scoreboard players add #action value 100000000"
                    elif "_vote_divider value run data get entity @s Pos[0]" in line:
                        lines[index] = line[:-49] + "_vote_divider value run data get entity @s Pos[2]"
                if arena[0] in ["cave", "ice"]:
                    if "execute if score #voting_side value >=" in line:
                        lines[index] = "execute if score #voting_side value <" + line[38:]
                    elif "execute if score #voting_side value <" in line:
                        lines[index] = "execute if score #voting_side value >=" + line[37:]
                if "~-16 ~ ~ 0 0" in line:
                    if arena[0] == "cave":
                        insert = "~016 ~ ~ 180 0"
                    elif arena[0] == "city":
                        insert = "~ ~ ~-16 90 0"
                    elif arena[0] == "ice":
                        insert = "~ ~ ~016 -90 0"
                    lines[index] = " ".join([" ".join(line.split(" ")[:-5]), insert])
                elif "~016 ~ ~ 0 0" in line:
                    if arena[0] == "cave":
                        insert = "~-16 ~ ~ 180 0"
                    elif arena[0] == "city":
                        insert = "~ ~ ~016 90 0"
                    elif arena[0] == "ice":
                        insert = "~ ~ ~-16 -90 0"
                    lines[index] = " ".join([" ".join(line.split(" ")[:-5]), insert])
                elif line == "execute if score @s even_or_odd matches 0 run scoreboard players remove #x value 16":
                    if arena[0] == "cave":
                        lines[index] = "execute if score @s even_or_odd matches 0 run scoreboard players add #x value 16"
                    elif arena[0] == "city":
                        lines[index] = "execute if score @s even_or_odd matches 0 run scoreboard players remove #z value 16"
                    elif arena[0] == "ice":
                        lines[index] = "execute if score @s even_or_odd matches 0 run scoreboard players add #z value 16"
                elif line == "execute if score @s even_or_odd matches 1 run scoreboard players add #x value 16":
                    if arena[0] == "cave":
                        lines[index] = "execute if score @s even_or_odd matches 1 run scoreboard players remove #x value 16"
                    elif arena[0] == "city":
                        lines[index] = "execute if score @s even_or_odd matches 1 run scoreboard players add #z value 16"
                    elif arena[0] == "ice":
                        lines[index] = "execute if score @s even_or_odd matches 1 run scoreboard players remove #z value 16"




            # Write contents to file
            if not os.path.exists(os.path.join(target_path, arena[0], local_path)):
                os.makedirs(os.path.join(target_path, arena[0], local_path))
            with open(os.path.join(target_path, arena[0], local_path, file), "w", encoding="utf-8") as f:
                f.write("\n".join(lines))







# End

print("Functions cloned successfully")
input()